#include <cstdio>
#include <cstring>
#include <iostream>
#include <Magick++.h>
#include <sstream>
using namespace Magick;
using namespace std;
#define BF_MAX_SALT_LEN 60
#define RANDBYTES 16
static const char base64_table[] =
	{ 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
	  'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	  'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
	  'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
	  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/', '\0'
	};

static const char base64_pad = '=';

unsigned char *php_base64_encode(const unsigned char *str, int length, int *ret_length)
{
	const unsigned char *current = str;
	unsigned char *p;
	unsigned char *result;

	if ((length + 2) < 0 || ((length + 2) / 3) >= (1 << (sizeof(int) * 8 - 2))) {
		if (ret_length != NULL) {
			*ret_length = 0;
		}
		return NULL;
	}

	result = (unsigned char *)malloc(((length + 2) / 3) * 4);
	p = result;

	while (length > 2) { /* keep going until we have less than 24 bits */
		*p++ = base64_table[current[0] >> 2];
		*p++ = base64_table[((current[0] & 0x03) << 4) + (current[1] >> 4)];
		*p++ = base64_table[((current[1] & 0x0f) << 2) + (current[2] >> 6)];
		*p++ = base64_table[current[2] & 0x3f];

		current += 3;
		length -= 3; /* we just handle 3 octets of data */
	}

	/* now deal with the tail end of things */
	if (length != 0) {
		*p++ = base64_table[current[0] >> 2];
		if (length > 1) {
			*p++ = base64_table[((current[0] & 0x03) << 4) + (current[1] >> 4)];
			*p++ = base64_table[(current[1] & 0x0f) << 2];
			*p++ = base64_pad;
		} else {
			*p++ = base64_table[(current[0] & 0x03) << 4];
			*p++ = base64_pad;
			*p++ = base64_pad;
		}
	}
	if (ret_length != NULL) {
		*ret_length = (int)(p - result);
	}
	*p = '\0';
	return result;
}
int main(int argc, char ** argv) { 
  unsigned char * buffer;
  int * ret_len;
  stringstream ss;
  InitializeMagick(*argv);
  Image image("album.jpg"); 
  Blob blob;
  image.magick("JPEG");
  image.write(&blob);
  std::string base = blob.base64();
  const void* data = blob.data();
  size_t dataLen = blob.length();
  Geometry size = image.size();
  cout << size.height() << endl;
  cout << size.width() << endl;
  cout << size.xOff() << endl;
  cout << size.yOff() << endl;
  cout << image.fileSize() << endl;
  cout << image.fileName() << endl;
  cout << image.format() << endl;
  cout << image.label() << endl;
  cout << image.magick() << endl;
  cout << image.quality() << endl;
  cout << image.comment() << endl;
  cout << base64("mydata") << endl;
  //cout << image.size() << endl;
  //printf("Width : %d, Height : %d\n", image.width(), image.height());
  //buffer = php_base64_encode(data.data(), dataLen, ret_len);
  //cout << buffer << endl;
  //free(buffer);
  return 0;
}